diff -r 1e55e1aa8b7f sys/netinet/tcp_subr.c
--- a/sys/netinet/tcp_subr.c	Sun May 04 01:33:02 2014 +0000
+++ b/sys/netinet/tcp_subr.c	Fri Jul 11 13:32:06 2014 +1000
@@ -42,9 +42,12 @@
 #include <sys/systm.h>
 #include <sys/callout.h>
 #include <sys/hhook.h>
+#include <sys/kdb.h>
 #include <sys/kernel.h>
 #include <sys/khelp.h>
+#include <sys/limits.h>
 #include <sys/sysctl.h>
+#include <sys/taskqueue.h>
 #include <sys/jail.h>
 #include <sys/malloc.h>
 #include <sys/mbuf.h>
@@ -53,6 +56,7 @@
 #endif
 #include <sys/priv.h>
 #include <sys/proc.h>
+#include <sys/queue.h>
 #include <sys/sdt.h>
 #include <sys/socket.h>
 #include <sys/socketvar.h>
@@ -92,6 +96,8 @@
 #include <netinet6/tcp6_var.h>
 #endif
 #include <netinet/tcpip.h>
+#include <netinet/mptcp_var.h>
+#include <crypto/sha1.h>
 #ifdef TCPDEBUG
 #include <netinet/tcp_debug.h>
 #endif
@@ -117,6 +123,10 @@
 
 #include <security/mac/mac_framework.h>
 
+/* for malloc'ing list heads */
+MALLOC_DECLARE(M_REASSLISTHEAD);
+MALLOC_DEFINE(M_REASSLISTHEAD, "reasshead", "Head of reass queue list");
+
 VNET_DEFINE(int, tcp_mssdflt) = TCP_MSS;
 #ifdef INET6
 VNET_DEFINE(int, tcp_v6mssdflt) = TCP6_MSS;
@@ -143,6 +153,7 @@
     &sysctl_net_inet_tcp_mss_check, "I",
     "Default TCP Maximum Segment Size");
 
+
 #ifdef INET6
 static int
 sysctl_net_inet_tcp_mss_v6_check(SYSCTL_HANDLER_ARGS)
@@ -166,6 +177,11 @@
    "Default TCP Maximum Segment Size for IPv6");
 #endif /* INET6 */
 
+VNET_DEFINE(unsigned int, tcp_override_isn) = 0;
+SYSCTL_VNET_UINT(_net_inet_tcp, OID_AUTO, override_isn, CTLFLAG_RW,
+    &VNET_NAME(tcp_override_isn), 0,
+    "Manually set the initial sequence number of TCP flows");
+
 /*
  * Minimum MSS we accept and use. This prevents DoS attacks where
  * we are forced to a ridiculous low MSS like 20 and send hundreds
@@ -231,6 +247,8 @@
 static char *	tcp_log_addr(struct in_conninfo *inc, struct tcphdr *th,
 		    void *ip4hdr, const void *ip6hdr);
 
+static void	tcp_sf_detach_locked(struct inpcb *inp);
+
 /*
  * Target size of TCP PCB hash tables. Must be a power of two.
  *
@@ -254,6 +272,13 @@
 	struct	osd		osd;
 };
 
+struct mppcb_mem {
+	struct	mpcb		mpcb;
+};
+
+static VNET_DEFINE(uma_zone_t, mpcb_zone);
+#define	V_mpcb_zone			VNET(mpcb_zone)
+
 static VNET_DEFINE(uma_zone_t, tcpcb_zone);
 #define	V_tcpcb_zone			VNET(tcpcb_zone)
 
@@ -372,6 +397,13 @@
 	uma_zone_set_max(V_tcpcb_zone, maxsockets);
 	uma_zone_set_warning(V_tcpcb_zone, "kern.ipc.maxsockets limit reached");
 
+	V_mpcb_zone = uma_zcreate("mpcb", sizeof(struct mppcb_mem),
+				    NULL, NULL, NULL, NULL, UMA_ALIGN_PTR, UMA_ZONE_NOFREE);
+		uma_zone_set_max(V_mpcb_zone, maxsockets);
+
+	/* zone for segments arriving before the mapping */
+	tcp_unmapped_init();
+
 	tcp_tw_init();
 	syncache_init();
 	tcp_hc_init();
@@ -402,6 +434,8 @@
 	TUNABLE_INT_FETCH("net.inet.tcp.soreceive_stream", &tcp_soreceive_stream);
 	if (tcp_soreceive_stream) {
 #ifdef INET
+		tcp_usrreqs.pru_soreceive = soreceive_generic;
+#else
 		tcp_usrreqs.pru_soreceive = soreceive_stream;
 #endif
 #ifdef INET6
@@ -747,6 +781,7 @@
 {
 	struct tcpcb_mem *tm;
 	struct tcpcb *tp;
+
 #ifdef INET6
 	int isipv6 = (inp->inp_vflag & INP_IPV6) != 0;
 #endif /* INET6 */
@@ -805,6 +840,27 @@
 		tp->t_flags |= TF_SACK_PERMIT;
 	TAILQ_INIT(&tp->snd_holes);
 	tp->t_inpcb = inp;	/* XXX */
+
+	/* insert head of list of reass queue heads */
+	tp->t_segq = malloc(sizeof(struct sf_reass_queue_head),
+			M_REASSLISTHEAD, M_NOWAIT | M_ZERO);
+
+	/* list of segments that have been received but do not have a map.
+	 * We hold on to them in case the map is yet to arrive. */
+	tp->t_unmapped_segq = malloc(sizeof(struct sf_unmapped_queue_head),
+			M_REASSLISTHEAD, M_NOWAIT | M_ZERO);
+
+	/*
+	 * pointer to the reassembly list head, which is inside the
+	 * sf_reass_queues_list (i.e. the list of reassembly queues
+	 */
+	TAILQ_INIT(tp->t_segq);
+	TAILQ_INIT(tp->t_unmapped_segq);
+
+	/* dss map queue */
+	TAILQ_INIT(&tp->t_txdsmaps);
+	TAILQ_INIT(&tp->t_rxdsmaps);
+
 	/*
 	 * Init srtt to TCPTV_SRTTBASE (0), so we can tell that we have no
 	 * rtt estimate.  Set rttvar so that srtt + 4 * rttvar gives
@@ -827,6 +883,211 @@
 	return (tp);		/* XXX */
 }
 
+
+struct mpcb *
+mp_newmpcb(struct inpcb *inp)
+{
+	struct mppcb_mem *mpm;
+	struct mpcb *mp;
+
+	mpm = uma_zalloc(V_mpcb_zone, M_NOWAIT | M_ZERO);
+	if (mpm == NULL)
+		return (NULL);
+	mp = &mpm->mpcb;
+	mp->master_inpcb = inp;
+	mp->master_socket = inp->inp_socket;
+	mp->subflow_cnt = 1;
+	mp->laddr_mask = 0;
+	mp->raddr_mask = 0;
+	mp->in_def_drop = 0;	// unused for now (to remove)
+	mp->mp_state = MPS_CLOSED;
+	mp->mp_flags = 0;
+
+	/* Init list of subflow tpcbs */
+	SLIST_INIT(&mp->tp_list);
+
+	/* List of subflow segment lists */
+	STAILQ_INIT(&mp->sf_reass_queues_list);
+
+	/* List of subflow send lists */
+	TAILQ_INIT(&mp->mp_ds_sndmaps);
+
+	/* List of ds-level segments awaiting rexmit */
+	TAILQ_INIT(&mp->mp_rxtmitmaps);
+
+	/* Init task queue handlers
+	 * XXXNJW: Some of these tasks are temporary and should be removed at some
+	 * point (e.g. datascheduler_task_handler used to kick tcp_output of
+	 * subflows while a proper packet scheduler is missing */
+
+	/* Asynchronous sending of MP_JOINs */
+	TASK_INIT(&mp->join_task, 0, mp_join_task_handler, mp);
+	/* XXXNJW: General Aysnchronous tasks... */
+	TASK_INIT(&mp->data_task, 0, mp_datascheduler_task_handler, mp);
+	/* set up pcb's for addresses advertised */
+	TASK_INIT(&mp->pcb_create_task, 0, mp_sf_alloc_task_handler, mp);
+	/* Perform rexmits when d-level RTO fires */
+	TASK_INIT(&mp->rexmit_task, 0, mp_rexmit_task_handler, mp);
+
+	/* initialise mutex for control block */
+	MPCB_LOCK_INIT(mp);
+
+	/*
+	 * pcb created by a TCP listener? if so then this will be set to '1' in
+	 * tcp_syncache (just prior to setting tp state to SYN_RECEIVED
+	 * XXXNJW: This is used as a temporary method to prevent hosts from
+	 * creating multiple subflows over the same pair of advertised IP
+	 * addresses
+	 */
+	mp->passive_open = 0;
+
+	/* When the data-level retransmit timer fires, it will acquire the
+	 * mp*/
+	callout_init(&mp->mpt_rexmt, CALLOUT_MPSAFE);
+
+	/* Zero the added address count - this increments when we receive
+	 * add_addr from the remote host */
+	mp->mp_added_address_count = 0;
+
+	/* Number of addresses available to this mp at creation time. Value may
+	 * differ from the global address count due to e.g. an interface not being
+	 * available at this time. */
+	mp->mp_conn_address_count = mp_address_count;
+
+	/*
+	 * Set the masks. We clear bits as ADD_ADDRs and JOINS are sent
+	 * for each of the subflows.
+	 */
+	uint32_t bitmask = 0xffffffff;
+	mp->mp_advaddr_mask = ~(bitmask << mp->mp_conn_address_count);
+
+	/* Update the advertise address mask and count of addresses available to
+	 * the session */
+	mp_update_available_addresses(mp);
+
+	/*
+	 * init the REASS lock. used for:
+	 * sf_reass_queues_list: when user process does reassembly
+	 * t_segq: when segments are inserted into the reassembly list
+	 */
+	SF_REASS_LOCK_INIT(mp);
+
+	return (mp);		/* XXX */
+
+}
+
+/*
+ * Free everything. locks, lists etc etc
+ *
+ */
+void
+mp_discardcb(struct mpcb *mp)
+{
+	/* Release any ds_maps that remain */
+    struct ds_map *map, *map_next;
+    map = TAILQ_FIRST(&mp->mp_ds_sndmaps);
+    while (map != NULL) {
+            map_next = TAILQ_NEXT(map, mp_ds_map_next);
+            free(map, M_DSSMAP);
+            map = map_next;
+    }
+
+    /* Release the list of segment queue heads */
+    struct sf_reass_queue_head *q_h, *nq_h;
+    q_h = STAILQ_FIRST(&mp->sf_reass_queues_list);
+	while (q_h != NULL) {
+		nq_h = STAILQ_NEXT(q_h, tqe_next_head);
+		/* reass queue elements flushed in tcp_discardcb */
+		free(q_h, M_REASSLISTHEAD);
+		q_h = nq_h;
+	}
+
+	SF_REASS_LOCK_DESTROY(mp);
+	uma_zfree(V_mpcb_zone, mp);
+
+}
+
+
+/*
+ * Tally up the acked bytes and remove and mark as ACKED any maps that have
+ * been fully sent and also acknowledged.
+ * XXXNJW: To be inlined, renamed
+ */
+void
+tcp_ackmap(struct tcpcb *tp, uint32_t acked, uint64_t data_ack_num)
+{
+	struct ds_map *map;
+	int completed_a_map = 0, first_map = 1;
+
+	do {
+		map = TAILQ_LAST(&tp->t_txdsmaps, dsmapq_head);
+		if (map != NULL) {
+
+			/* This map could have been restransmitted on another subflow and
+			 * already acked at the data-level. In this case mbuf_start would
+			 * have been set to NULL, and it would have been removed from
+			 * mp_ds_sndmaps. Remove it from the map list and free the map. */
+//			if (map->flags & MAPF_IS_DUP) {
+//				printf("%s: map already acked at ds-level, deleting\n",
+//				    __func__);
+//				TAILQ_REMOVE(&tp->t_txdsmaps, map, sf_ds_map_next);
+//				free(map, M_DSSMAP);
+//				continue;
+//			}
+
+			if (first_map) {
+				if (map->sf_seq_start <= tp->snd_una)
+					acked += tp->snd_una -  map->sf_seq_start;
+				else /* una has wrapped */
+					acked += (UINT_MAX - map->sf_seq_start) + tp->snd_una;
+				first_map = 0;
+			}
+
+			/*
+			 * If acked more than the length of the current map, then we can
+			 * remove it from the transmit ds_maps list and classify this map
+			 * as having been 'ACKED'. The map itself will be deallocd at the
+			 * mp layer once the data-level has been acked.
+			 */
+			if (acked >= map->ds_map_len) {										// need to clear rexmit maps that were queued but not
+				KASSERT((map->flags & MAPF_IS_SENT) ||							// yet sent
+				    (map->flags & MAPF_IS_REXMIT),
+				    ("map %p acked but not marked as sent", map));
+
+				/* This ack cumulatively acks all bytes outstanding in this map. */
+				TAILQ_REMOVE(&tp->t_txdsmaps, map, sf_ds_map_next);
+				/* Must come after TAILQ_REMOVE so mp_deferred_sbdrop
+				 * can't trash the link. */
+				map->flags |= MAPF_IS_ACKED;
+
+				acked -= map->ds_map_len;
+				completed_a_map++;
+
+				if (tp->infinite_map && map->ds_map_start
+						== tp->t_mpcb->ds_snd_una) {
+					tp->t_mpcb->ds_snd_una += map->ds_map_len;
+				}
+			/* else: TAILQ is empty or no more maps in the list
+			 * are covered by this ack */
+			} else
+				map = NULL;
+
+		}
+	} while (map != NULL);
+
+	if (tp->infinite_map && completed_a_map) {
+		mp_deferred_sbdrop(tp->t_mpcb);
+	}
+
+	/*
+	 * Got a data-level ACK.
+	 * mp_data_ack() locks the mpcb
+	 */
+	if (data_ack_num > 0) {
+		mp_data_ack(tp->t_mpcb, data_ack_num);
+	}
+}
+
 /*
  * Switch the congestion control algorithm back to NewReno for any active
  * control blocks using an algorithm which is about to go away.
@@ -909,9 +1170,19 @@
 		TCPSTAT_INC(tcps_drops);
 	} else
 		TCPSTAT_INC(tcps_conndrops);
-	if (errno == ETIMEDOUT && tp->t_softerror)
-		errno = tp->t_softerror;
-	so->so_error = errno;
+
+	/* XXXNJW: will stop application from closing due to timeout. the subflow
+	 * will still get released and the connection can keep going. This is a
+	 * temp solution to prevent timeout out subflows from triggering a disco
+	 * pru call from the socket.
+	 */
+	if (tp->t_mpcb != NULL) {
+		if (tp->t_mpcb->subflow_cnt == 1) {
+			if (errno == ETIMEDOUT && tp->t_softerror)
+				errno = tp->t_softerror;
+			so->so_error = errno;
+		}
+	}
 	return (tcp_close(tp));
 }
 
@@ -1003,9 +1274,24 @@
 		tcp_hc_update(&inp->inp_inc, &metrics);
 	}
 
-	/* free the reassembly queue, if any */
+	/* free the reassembly queue, if any
+	 * XXXNJW: If a subflow has called into tcp_discard, could we still need
+	 * to retain the segments, in cases where there is some disorder and these
+	 * segments will be needed to reassemble later? */
 	tcp_reass_flush(tp);
 
+	/* free any unmapped segments being buffered */
+	tcp_unmapped_flush(tp);
+
+	/* free ds_maps from t_rxmaps */
+	struct ds_map *n1, *n2;
+	n1 = TAILQ_FIRST(&tp->t_rxdsmaps);
+    while (n1 != NULL) {
+            n2 = TAILQ_NEXT(n1, sf_ds_map_next);
+            free(n1, M_DSSMAP);
+            n1 = n2;
+    }
+
 #ifdef TCP_OFFLOAD
 	/* Disconnect offload device, if any. */
 	if (tp->t_flags & TF_TOE)
@@ -1020,6 +1306,52 @@
 
 	khelp_destroy_osd(tp->osd);
 
+	if (tp->t_mpcb != NULL) {
+		mp_debug(MPSESSION, 4, 0,"%s: subflow count: %d\n", __func__,
+		    tp->t_mpcb->subflow_cnt);
+
+		/* discard the mp if we are in the processing of closing the last */
+		if (tp->t_mpcb->subflow_cnt == 1 &&
+		    (so->so_state & SS_ISDISCONNECTED) == 0) {
+				/* Workaround that prevents an early socket free */
+				SOCK_LOCK(so);
+				inp->inp_socket->so_state |= SS_PROTOREF;
+				SOCK_UNLOCK(so);
+				inp->inp_flags |= INP_SOCKREF;
+
+				mp_debug(MPSESSION, 1, 0,"%s: destroy mp\n", __func__);
+				mp_discardcb(tp->t_mpcb);
+				mp_debug(MPSESSION, 1, 0,"%s: flush buffers\n", __func__);
+				soisdisconnected(inp->inp_socket);
+		} else {
+			/* Decrement the subflow count of the connection. subflow_cnt is
+			 * incremented once the pcb's are allocated and the subflow enters
+			 * LISTEN or SYN_SENT (sf_join_task_handler, sf_alloc_task_handler
+			 * XXNJW: Also just temporary */
+			mp_debug(MPSESSION, 4, 0,"%s: decrement sf count on tp %p\n",
+			    __func__, tp);
+			tp->t_mpcb->subflow_cnt -= 1;
+//				if (tp->t_mpcb->subflow_cnt != 1)
+			inp->inp_flags &= ~INP_SOCKREF;
+
+			/* XXXNJW: related to the temporary schedular. If the subflow was
+			 * waiting for data just decrement the counter, to keep the count
+			 * accurate (it may be inflated by one, causing the remaining
+			 * subflow to defer getting a map on every other call through
+			 * tcp_output. */
+			if (tp->sf_flags & SFF_DATA_WAIT)
+				atomic_subtract_acq_int(&tp->t_mpcb->data_wait_count, 1);
+
+			/* remove the subflow tp from the list of tp's on this mp
+			 * connection, so that it is not dereferenced in future calls to
+			 * tcp_usr_disconnect, etc. The inpcb is probably about to be
+			 * dropped and dealloced anyway so there's not much that can be
+			 * done with the tp after that. */
+			mp_drop_subflow_tp(tp->t_mpcb, tp);
+
+		}
+	}
+
 	CC_ALGO(tp) = NULL;
 	inp->inp_ppcb = NULL;
 	tp->t_inpcb = NULL;
@@ -1036,6 +1368,9 @@
 	struct inpcb *inp = tp->t_inpcb;
 	struct socket *so;
 
+	mp_debug(MPSESSION, 1, 0,"%s: entered, tp %p, mp_enabled %d\n", __func__,
+	    tp, tp->mp_enabled);
+
 	INP_INFO_WLOCK_ASSERT(&V_tcbinfo);
 	INP_WLOCK_ASSERT(inp);
 
@@ -1047,21 +1382,119 @@
 	TCPSTAT_INC(tcps_closed);
 	KASSERT(inp->inp_socket != NULL, ("tcp_close: inp_socket NULL"));
 	so = inp->inp_socket;
-	soisdisconnected(so);
+
+	/*
+	 * For multipath connections, do not want to set the socket as
+	 * disconnected until the very last subflow is closing. However
+	 * subflows closing before that should still be detached.
+	 *
+	 * If this is a last remaining tp, then set stong socket reference flag
+	 * and set this inp as the pcb of the socket (the original inp might
+	 * have been released at this point).
+	 *
+	 * XXXNJW: temporary. to be redone when shutdown process is overhauled.
+	 */
+	if (tp->t_mpcb != NULL) {
+	    if (tp->t_mpcb->subflow_cnt == 1) {
+	    	if (tp->t_state >= TCPS_ESTABLISHED ||
+	    	    tp->t_state == TCPS_CLOSED) {
+				SOCK_LOCK(so);
+				so->so_state |= SS_PROTOREF;
+				SOCK_UNLOCK(so);
+				inp->inp_flags |= INP_SOCKREF;
+				so->so_pcb = (caddr_t)inp;
+	    	}
+	    	soisdisconnected(so);
+	    } else {
+	    	inp->inp_flags &= ~INP_SOCKREF;
+	    	mp_debug(MPSESSION, 1, 0, "%s: sf_detach on tp %p\n", __func__, tp);
+	    	tcp_sf_detach_locked(tp->t_inpcb);
+	    	return (NULL);
+	    }
+	} else {
+		soisdisconnected(so);
+	}
+
 	if (inp->inp_flags & INP_SOCKREF) {
 		KASSERT(so->so_state & SS_PROTOREF,
 		    ("tcp_close: !SS_PROTOREF"));
 		inp->inp_flags &= ~INP_SOCKREF;
 		INP_WUNLOCK(inp);
 		ACCEPT_LOCK();
+		KASSERT(inp != NULL, ("%s: inp == NULL", __func__));
 		SOCK_LOCK(so);
 		so->so_state &= ~SS_PROTOREF;
+		mp_debug(MPSESSION, 1, 0, "%s: calling sofree with tp %p\n", __func__,
+		    tp);
 		sofree(so);
 		return (NULL);
 	}
 	return (tp);
 }
 
+/*
+ * This is similar to the tcp_detach function in tcp_ussreq. However
+ * We are replacing call to inpcbdetach() with inp->inp_socket = NULL;
+ * This is done as inpcbdeteach will set so->so_pcb to NULL, which
+ * can cause KASSERT to fail when in multi-subflow connections. I.e.
+ * this function is only ever called by a subflow that isn't the last
+ * subflow being closed on the connection. The last subflow to close
+ * will detach the inp in the standard way.
+ */
+static void
+tcp_sf_detach_locked(struct inpcb *inp) {
+	struct tcpcb *tp;
+
+	tp = intotcpcb(inp);
+
+	if (inp->inp_flags & INP_TIMEWAIT) {
+		/*
+		 * There are two cases to handle: one in which the time wait
+		 * state is being discarded (INP_DROPPED), and one in which
+		 * this connection will remain in timewait.  In the former,
+		 * it is time to discard all state (except tcptw, which has
+		 * already been discarded by the timewait close code, which
+		 * should be further up the call stack somewhere).  In the
+		 * latter case, we detach from the socket, but leave the pcb
+		 * present until timewait ends.
+		 *
+		 * XXXRW: Would it be cleaner to free the tcptw here?
+		 */
+		if (inp->inp_flags & INP_DROPPED) {
+			KASSERT(tp == NULL, ("tcp_sf_detach_locked: INP_TIMEWAIT && "
+				"INP_DROPPED && tp != NULL"));
+			inp->inp_socket = NULL;
+			in_pcbfree(inp);
+		} else {
+			inp->inp_socket = NULL;
+			INP_WUNLOCK(inp);
+		}
+	} else {
+		/*
+		 * If the connection is not in timewait, we consider two
+		 * two conditions: one in which no further processing is
+		 * necessary (dropped || embryonic), and one in which TCP is
+		 * not yet done, but no longer requires the socket, so the
+		 * pcb will persist for the time being.
+		 *
+		 * XXXRW: Does the second case still occur?
+		 */
+		if (inp->inp_flags & INP_DROPPED ||
+			tp->t_state < TCPS_SYN_SENT) {
+			mp_debug(MPSESSION, 4, 0,
+			    "%s: discarding non-timewait/inp_dropped tp %p\n", __func__,
+			    tp);
+			tcp_discardcb(tp);
+			inp->inp_socket = NULL;
+			in_pcbfree(inp);
+		} else {
+			inp->inp_socket = NULL;
+			INP_WUNLOCK(inp);
+		}
+	}
+
+}
+
 void
 tcp_drain(void)
 {
@@ -1664,6 +2097,9 @@
 
 	INP_WLOCK_ASSERT(tp->t_inpcb);
 
+	if (V_tcp_override_isn)
+		return V_tcp_override_isn;
+
 	ISN_LOCK();
 	/* Seed if this is the first use, reseed if requested. */
 	if ((V_isn_last_reseed == 0) || ((V_tcp_isn_reseed_interval > 0) &&
@@ -2413,6 +2849,9 @@
 	int pstate = tp->t_state;
 #endif
 
+	mp_debug(MPSESSION, 1, 0, "%s: changing tp %p state to: %d\n", __func__,
+	    tp, newstate);
+
 	tp->t_state = newstate;
 	TCP_PROBE6(state__change, NULL, tp, NULL, tp, NULL, pstate);
 }
